## lem 1.0

=== DESCRIPTION ===
Package: lem
Title: Linear Effects Models
Version: 1.0
Author: Ewa Szczurek
Description: Methods for simulating and inferring linear effects models
Reference: Szczurek E, Beerenwinkel N, Linear effects models of
        signaling pathways from combinatorial perturbation data,
        Bioinformatics. 2016 Jun 15;32(12):i297-i305. doi:
        10.1093/bioinformatics/btw268.
Maintainer: Ewa Szczurek <szczurek@mimuw.edu.pl>
Depends: R (>= 3.0)
Imports: methods, stats, e1071
biocViews: Bioinformatics, GraphsAndNetworks, Pathways, SystemsBiology,
        NetworkInference
URL: http://www.bioconductor.org
License: GPL (>= 2)
Packaged: 2019-01-28 23:11:13 UTC; ewaszczurek
NeedsCompilation: no
