=== examples/ocaml_light/Makefile ===
all:

DIR=~/rsem/ott/examples/caml
getmodel:
	make -C $(DIR) lemtest
	cp $(DIR)/caml_typedef.lem           .
	cp $(DIR)/caml_typedef_reduction.ott .
	cp $(DIR)/caml_typedef_syntax.ott    .
	cp $(DIR)/caml_typedef_typing.ott    .
