## lem 2022-12-10+dfsg2

=== debian/changelog ===
lem (2022-12-10+dfsg2-4build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 10:56:19 +0100

lem (2022-12-10+dfsg2-4) unstable; urgency=medium

  * Team upload
  * Fix build on bytecode architectures (Closes: #1084815)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 Oct 2024 11:25:29 +0200

lem (2022-12-10+dfsg2-3) unstable; urgency=medium

  * Update liblem-ocaml-dev.install.in

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 23 Sep 2024 14:56:56 +0800

lem (2022-12-10+dfsg2-2) unstable; urgency=medium

  * Update batUChar.* and batUTF8.* license.
  * Remove unused license paragraph on lgpl-2.

 -- Bo YU <tsu.yubo@gmail.com>  Tue, 17 Sep 2024 14:24:42 +0800

lem (2022-12-10+dfsg2-1) unstable; urgency=low

  * Initial release. (Closes: #1065658)

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 23 Jun 2024 07:39:43 +0800
