## lem 2025-03

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Attempt to ask git for a version (tag or hash) but fall back on LEMRELEASE.
 # Note that opam builds from a tar ball so LEMRELEASE will be used in that case.
-LEMRELEASE:=2022-12-10
+LEMRELEASE:=2025-03-13
 LEMVERSION:=$(shell git describe --dirty --always 2>/dev/null || echo $(LEMRELEASE))
 
 DDIR=lem-$(LEMVERSION)
@@ -14,23 +14,23 @@
 # we might want run the tests for all backends that are present
 
 install:
-	mkdir -p $(INSTALL_DIR)/bin
-	rm -f $(INSTALL_DIR)/bin/lem
-	cp src/main.native $(INSTALL_DIR)/bin/lem
-	rm -rf $(INSTALL_DIR)/share/lem
-	mkdir -p $(INSTALL_DIR)/share/lem/library
-	cp library/*.lem $(INSTALL_DIR)/share/lem/library
-	cp library/*_constants $(INSTALL_DIR)/share/lem/library
+	mkdir -p "$(INSTALL_DIR)/bin"
+	rm -f "$(INSTALL_DIR)/bin/lem"
+	cp src/main.native "$(INSTALL_DIR)/bin/lem"
+	rm -rf "$(INSTALL_DIR)/share/lem"
+	mkdir -p "$(INSTALL_DIR)/share/lem/library"
+	cp library/*.lem "$(INSTALL_DIR)/share/lem/library"
+	cp library/*_constants "$(INSTALL_DIR)/share/lem/library"
 	$(MAKE) -C ocaml-lib install
-	cp -R coq-lib $(INSTALL_DIR)/share/lem
-	cp -R hol-lib $(INSTALL_DIR)/share/lem
-#	cp -R html-lib $(INSTALL_DIR)/share/lem
-	cp -R isabelle-lib $(INSTALL_DIR)/share/lem
-#	cp -R tex-lib $(INSTALL_DIR)/share/lem
+	cp -R coq-lib "$(INSTALL_DIR)/share/lem"
+	cp -R hol-lib "$(INSTALL_DIR)/share/lem"
+#	cp -R html-lib "$(INSTALL_DIR)/share/lem"
+	cp -R isabelle-lib "$(INSTALL_DIR)/share/lem"
+#	cp -R tex-lib "$(INSTALL_DIR)/share/lem"
 
 uninstall:
-	rm -f $(INSTALL_DIR)/bin/lem
-	rm -rf $(INSTALL_DIR)/share/lem
+	rm -f "$(INSTALL_DIR)/bin/lem"
+	rm -rf "$(INSTALL_DIR)/share/lem"
 	$(MAKE) -C ocaml-lib uninstall
 
 build-doc:
@@ -186,6 +186,7 @@
 
 
 lem: build-lem
+	true
 
 bin/lem: lem
 	mkdir -p bin
