=== tests/Makefile ===
all:
	$(MAKE) -C ident_backend
	$(MAKE) -C type_errors
	$(MAKE) -C backends

clean:
	-$(MAKE) -C ident_backend clean
	-$(MAKE) -C type_errors clean
	-$(MAKE) -C backends clean
