=== tex-lib/Makefile ===
all:
	$(MAKE) -C .. tex-libs

clean:
	rm -f *.toc *.aux *.ps *.log *.lof *.bbl *.blg *.hix *.tid *.tde *.out *~
