=== ocaml-lib/num_impl_num/Makefile ===
clean:
	\rm -f *.c* *.o *.cma *.cmxa *.a
