## lem 2025-03-13+dfsg

=== debian/changelog ===
lem (2025-03-13+dfsg-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Aug 2025 09:38:21 +0200

lem (2025-03-13+dfsg-1) unstable; urgency=medium

  * New upstream version 2025-03-13+dfsg. (Closes: #1105410)
  * Rebase debian/patches/
  * Bump Standards-Version to 4.7.2 (no changes)
  * Update year of d/copyright
  * Update my Debian email

 -- Bo YU <vimer@debian.org>  Tue, 27 May 2025 19:03:45 +0800
