=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg.*$//,repacksuffix=+dfsg,compression=xz \
https://github.com/rems-project/lem/tags .*/archive/.*/(\d\S+)\.tar\.gz
